@Herding.@
@To calculate T_3 tests, set lagged_consensus = 0.@
@The T_1 and T_2 tests can be calculated with both lagged_consensus = 0 and lagged_consensus = 1@; 

new; cls;
format /RDN 12,4;

output file =  c:\jmcb_16-171\results.out reset; 
all_resps = 1; @1 = Include all respondents. 0 = only those who responded >11 times.
				 Including all respondents means that the aggregates match the SPF-produced series@  
rtds = 1;      @1 real time actuals (2nd release), 0 gives latest vintage @
output684 = 1; @=1 output from 1968:4. =0 from 1981:3@
hcse = 1;      @ =0 OLS SEs; =1 White SEs @
disp = 0;      @=1: cross-sectional variance included; =0: excluded@ 

lagged_consensus = 1; @1: Use consensus lagged 1 period relative to longest individual forecast. 0: Use current consensus@
min_nobs = 29;	min_nobs = 9;

Experiment = 1;
do while Experiment <= 2;
     if Experiment == 1; inflation = 0;		endif;
     if Experiment == 2; inflation = 1;		endif;
 
"Include all respondents";; all_resps;
"Real time actual data ";;rtds; 

data_on_y =  zeros(46,2); @68 - 13. stores annual actual growth rates@

if inflation; 
load y0[] = c:\jmcb_16-171\pQvQd.csv;
else;
load y0[] = c:\jmcb_16-171\ROUTPUTQvQd.csv;
endif;

y0 = reshape(y0,269,196);
y0 = miss(y0,-999);

 @all RTDSMs. First column, time, then 65:4 vintage, data from 47:1 to 65:3.
    		  Last column, 14:2 vintage, data from 47:1 to 14:1.@
y1q = miss(zeros(268,195),0);			  
@Calculate % change@
y1q = 100*(y0[2:269,2:196]./y0[1:268,2:196] -1);


@qly series of annual average growth rates for 1968 to 2013, for qtrs 68:4 to 2013:4, latest vintage 14Q2@   
ann_lasts = sumc(reshape(y0[81:268,196],47,4)');  @1967 to 2013@
ann_lasts = 100*((ann_lasts[2:47,1]./ann_lasts[1:46,1])-1);
q_ann_lasts = ones(1,1)*ann_lasts[1,1];	
j=2; do while j <= 46; q_ann_lasts = q_ann_lasts|(ones(4,1)*ann_lasts[j,1]);
data_on_y[j,1] = ann_lasts[j,1];j=j+1;endo; 

data_on_y[.,1] = ann_lasts;

@qly series of annual average growth rates for 1968 to 2010, for qtrs 68:4 to 2013:4, 2nd release vintage@
j=1; 
temp = y0[84+(4*j)-7:84+(4*j),12+(4*j)];				 
temppc = 100*((sumc(temp[5:8])/sumc(temp[1:4]))-1);		 
data_on_y[1,2] = temppc;
q_ann_rtds = ones(1,1)*temppc;
j=2; do while j <= 46;
temp = y0[84+(4*j)-7:84+(4*j),12+(4*j)];				 
temppc = 100*((sumc(temp[5:8])/sumc(temp[1:4]))-1);
q_ann_rtds = q_ann_rtds|ones(4,1)*temppc;				 
data_on_y[j,2] = temppc;
j=j+1;endo;


if     rtds == 1; actuals =  q_ann_rtds;
else;  actuals =  q_ann_lasts;
endif;

yq0 = miss(zeros(177,1),0);
yq1 = miss(zeros(177,1),0);
yq2 = miss(zeros(177,1),0);
yq3 = miss(zeros(177,1),0);
yq4 = miss(zeros(177,1),0);
j=1; do while j .le 177;   @actuals corresponding to current forecast, next, up to + 4@		@surveys 68:4 to 2012:4@ 
yq0[j,1] = y1q[86+j,14+j];
yq1[j,1] = y1q[86+j+1,14+j+1];
yq2[j,1] = y1q[86+j+2,14+j+2];
yq3[j,1] = y1q[86+j+3,14+j+3];
yq4[j,1] = y1q[86+j+4,14+j+4];
j=j+1;endo;

if output684 .== 0;
  if inflation .== 0;
  actuals = actuals[52:rows(actuals),.]; @output growth ditches 68:4 to 81:2 observations@
   yq0 = yq0[52:rows(yq0),.];
   yq1 = yq1[52:rows(yq1),.];
   yq2 = yq2[52:rows(yq2),.];
   yq3 = yq3[52:rows(yq3),.];
   yq4 = yq4[52:rows(yq4),.];
  endif;
endif;

noq = 181;
if output684 .== 0;
  if inflation;
  noq = 181; @# surveys 68:4 to 2013:4@		
  else;
  noq = 130; @# surveys 81:3 to 2013:4@		
  endif;
endif;

@downloaded June 16th 2014: only use data to 2013:Q4 @
 @1@
 @ There are 7344 rows relating to a particular variable
 (all individuals and all dates (68:4 to 2013:4)) @ 
if inflation;
 load xd[] = c:\jmcb_16-171\Individual_PGDP.csv;
  xd = reshape(xd,7344,12);
else;
 load xd[] = c:\jmcb_16-171\Individual_RGDP.csv;
  xd = reshape(xd,7344,14);	xd = xd[.,1:12];
endif;

  d = xd[.,1 2 3 5:10];
  d[.,1] = d[.,1] + d[.,2]/10;
  d = d[.,1 3:9];
@Structure of d.  col 1 = date; col 2 = id;  cols 3 - 8 are previous period forecast, current, next 1 to 4 qtrs@
  
d[.,1:7] = miss(d[.,1:7],-999);

d = packr(d);
maxi= maxc(d[.,2]);	@highest respondent id@
resps = seqa(1,1,maxi);
nresps = resps~sumc((resps .eq d[.,2]')');
"Total no of respondents "; nids =  sumc(nresps[.,2] .gt 0); nids;
ids = rev(sortc(nresps,2));
ids = ids[1:nids,.]; @ids with most responses: no of responses, to least.@ 

if all_resps == 0;
nf = sumc(ids[.,2] .gt 11);	 @respondents filed 12 or more returns@
"no respondents filing 12 or more ";;nf; 
@Define d to include responses from only the top nf respondents@ 
m = d[.,2] .eq ids[1:nf,1]';
d = selif(d,sumc(m'));
else;

nf = sumc(ids[.,2] .gt 0);	 @respondents filed 1 or more returns@

endif;					  

fq0 = miss(zeros(noq,nf),0);	@forecast of current quarter qly % change@
fq1 = miss(zeros(noq,nf),0);	@forecast of next (+1) quarter qly % change@
fq2 = miss(zeros(noq,nf),0);	@forecast of +2 quarter qly % change@
fq3 = miss(zeros(noq,nf),0);	@forecast of +3 quarter qly % change@
fq4 = miss(zeros(noq,nf),0);	@forecast of +4 quarter qly % change@

idmatrix = miss(zeros(noq,nf),0);	@ identifiers of respondents@
d[.,8] = miss(d[.,8],-999);

ydate = 1968.4;	og = 0;

if output684 .== 0;
  if inflation;
  ydate = 1968.4; og = 0;
  else;
  ydate = 1981.3; og = 51; d = selif(d,d[.,1] .gt 1981.2);  
  endif;
endif;  


   q=1; w=1;  dates = ydate;
    j=1; do while j <= rows(d);

	
			   		if d[j,1] == ydate;						   


  fq0[q,w] = 100*(d[j,4]/d[j,3] - 1);
  fq1[q,w] = 100*(d[j,5]/d[j,4] - 1);
  fq2[q,w] = 100*(d[j,6]/d[j,5] - 1);
  fq3[q,w] = 100*(d[j,7]/d[j,6] - 1);
  fq4[q,w] = 100*(d[j,8]/d[j,7] - 1);
  
					


	idmatrix[q,w]   = d[j,2];  
			
   	 
	 
     	    w=w+1; 
			else; ydate = d[j,1]; q=q+1; j=j-1; w=1; dates = dates|ydate;    

			endif;
	j=j+1;endo;


 /**********************Sorting forecasts by individual**********************/
   
   i_fq0 =  miss(zeros(noq,nf),0);
   i_fq1 =  miss(zeros(noq,nf),0);
   i_fq2 =  miss(zeros(noq,nf),0);
   i_fq3 =  miss(zeros(noq,nf),0);
   i_fq4 =  miss(zeros(noq,nf),0);

   
  q=1; do while q <= noq;
		
	w=1;
	do while w <= nf;
	     		
				   j=1; do while j <= nf;

				   		
				            if idmatrix[q,j] == ids[w,1];
						   i_fq0[q,w] =	  fq0[q,j];
						   i_fq1[q,w] =	  fq1[q,j];
						   i_fq2[q,w] =	  fq2[q,j];
						   i_fq3[q,w] =	  fq3[q,j];
						   i_fq4[q,w] =	  fq4[q,j];
						
								j = nf+1; 
						    endif;
				   j=j+1; endo;
	w=w+1;	endo;
				   
  q=q+1; endo;

/*Begin. Individual-level forecasts of growth rates*/

@calculate medians@;
herdres_i_q = miss(zeros(nf*4,26),0); @records id, qtr, #, test outcomes@;
ggj_i_q	    = miss(zeros(nf*4,11),0); @records id, qtr, #, test outcomes of Gallo, Granger & Jeon test@;

medfq0 = miss(zeros(noq-4,1),0);
medfq1 = miss(zeros(noq-4,1),0);
medfq2 = miss(zeros(noq-4,1),0);
medfq3 = miss(zeros(noq-4,1),0);
medfq4 = miss(zeros(noq-4,1),0);

stdfq0 = miss(zeros(noq-4,1),0);
stdfq1 = miss(zeros(noq-4,1),0);
stdfq2 = miss(zeros(noq-4,1),0);
stdfq3 = miss(zeros(noq-4,1),0);
stdfq4 = miss(zeros(noq-4,1),0);

j=1; do while j .le noq -4;
medfq0[j,1] = median(packr(i_fq0[j,.]'));
medfq1[j,1] = median(packr(i_fq1[j,.]'));
medfq2[j,1] = median(packr(i_fq2[j,.]'));
medfq3[j,1] = median(packr(i_fq3[j,.]'));
medfq4[j,1] = median(packr(i_fq4[j,.]'));

stdfq0[j,1] = (stdc(packr(i_fq0[j,.]')))^2;
stdfq1[j,1] = (stdc(packr(i_fq1[j,.]')))^2;
stdfq2[j,1] = (stdc(packr(i_fq2[j,.]')))^2;
stdfq3[j,1] = (stdc(packr(i_fq3[j,.]')))^2;
stdfq4[j,1] = (stdc(packr(i_fq4[j,.]')))^2;

j=j+1;endo;

j=1; do while j <= nf;
@Fixed-event forecasts@
b01 =i_fq0[2:noq-3,j]~i_fq1[1:noq-4,j]~medfq1~yq1~stdfq1;
b12 =i_fq1[2:noq-3,j]~i_fq2[1:noq-4,j]~medfq2~yq2~stdfq2;
b23 =i_fq2[2:noq-3,j]~i_fq3[1:noq-4,j]~medfq3~yq3~stdfq3;
b34 =i_fq3[2:noq-3,j]~i_fq4[1:noq-4,j]~medfq4~yq4~stdfq4;

if lagged_consensus;
b01 =i_fq0[3:noq-3,j]~i_fq1[2:noq-4,j]~medfq2[1:noq-5,1]~yq1[2:noq-4,1]~stdfq2[1:noq-5,1];
b12 =i_fq1[3:noq-3,j]~i_fq2[2:noq-4,j]~medfq3[1:noq-5,1]~yq2[2:noq-4,1]~stdfq3[1:noq-5,1];
b23 =i_fq2[3:noq-3,j]~i_fq3[2:noq-4,j]~medfq4[1:noq-5,1]~yq3[2:noq-4,1]~stdfq4[1:noq-5,1];
b34 = miss(0,0);													  
endif;

hac = 1;
qqq=1; do while qqq .le 4; 
if qqq == 1; bq = b01; hh =1; elseif qqq == 2; bq = b12; hh=2; elseif qqq == 3; bq = b23; hh=3; elseif qqq .== 4; bq = b34; hh=4; endif; 
if rows(packr(bq)) .le min_nobs;  goto fin2; endif;
herdres_i_q[4*(j-1)+qqq,.] = ids[j,1]~qqq~rows(bq)~herd_test(bq[.,1:4],hh,hac);		@Herding test@
 if disp == 1;
 ggj_i_q[4*(j-1)+qqq,.] = ids[j,1]~qqq~rows(bq)~ggj_test(bq[.,1:3],bq[.,5]);     @GGJ Herding test. Group variance included@ 
 else;
 ggj_i_q[4*(j-1)+qqq,.] = ids[j,1]~qqq~rows(bq)~ggj_test(bq[.,1:3],1);           @GGJ Herding test. Group variance not included@
 endif;
fin2:
qqq=qqq+1;endo;

j=j+1;endo;

if inflation;
dset = "inflation_q_dat";
dset = "c:\\jmcb_16-171\\" $+ dset;			 
dset1 = "inflation_GGJq_dat";
dset1 = "c:\\jmcb_16-171\\" $+ dset1;
save ^dset = herdres_i_q;
save ^dset1 = ggj_i_q; 
else;
dset = "output_q_dat";
dset = "c:\\jmcb_16-171\\" $+ dset;
dset1 = "output_GGJq_dat";
dset1 = "c:\\jmcb_16-171\\" $+ dset1;
save ^dset = herdres_i_q; 
save ^dset1 = ggj_i_q; 
endif;

format /RDN 12,4;

proc(1) = herd_test(Z,hh,hac);
local Zmiss, nM, eM, lhs, rhs, k, fe,f,f1,c1,n,p,regX,inXX,depv,e,s_sq,tstat1,tstat2,tstat3,tstat4,b1,b2,b3,b4,w,wi,w1,w2, a,gamp,gamn,delp,deln,prob1,prob2,esd,Sstat,lb,ub,signif_h,signif_a,n1,n2,n3,n4;
Zmiss = Z;
Z = packr(Z);
f =  Z[.,1];
f1 = Z[.,2];
c1 = Z[.,3];
a =  Z[.,4];
fe = a - f;
n  = rows(Z);

@revision: constant, lagged consensus@ 	 
regX = ones(n,1)~c1;
inXX = invpd(regX'regX);
depv = f - f1;
b1 = inXX*regX'depv;
e = depv - regX*b1;
if hcse == 0;
s_sq = (1/(n-2))*(e'e)*invpd(regX'regX);
else; 
s_sq = (1/(n-2))*(e.*regX)'(e.*regX);
s_sq = n*invpd(regX'regX)*s_sq*invpd(regX'regX);
endif;
tstat1 = b1[2,1]/(SQRT(s_sq[2,2]));


@revision: constant, f1 - c1@ 
regX = ones(n,1)~(f1-c1);
inXX = invpd(regX'regX);
depv = f - f1;
b2 = inXX*regX'depv;
e = depv - regX*b2;
if hcse == 0;
s_sq = (1/(n-2))*(e'e)*invpd(regX'regX);
else; 
s_sq = (1/(n-2))*(e.*regX)'(e.*regX);
s_sq = n*invpd(regX'regX)*s_sq*invpd(regX'regX);
endif;
tstat2 = b2[2,1]/(SQRT(s_sq[2,2]));

@forecast error on f1 - c1@
depv = fe;
b3 = inXX*regX'depv;
e = depv - regX*b3;
if hcse == 0;
s_sq = (1/(n-2))*(e'e)*invpd(regX'regX);
else; 
s_sq = (1/(n-2))*(e.*regX)'(e.*regX);
s_sq = n*invpd(regX'regX)*s_sq*invpd(regX'regX);
endif;
tstat3 = b3[2,1]/(SQRT(s_sq[2,2]));

@forecast error on f - c1@
nM  = rows(Zmiss);
lhs = Zmiss[.,4] - Zmiss[.,1];
rhs = ones(nM,1)~(Zmiss[.,1] - Zmiss[.,3]);
n = rows(z);
regX = ones(n,1)~(Z[.,1] - Z[.,3]);
k = cols(regX);
inXX = invpd(regX'regX);
depv =  Z[.,4] - Z[.,1];
b4 = inXX*regX'depv;
e = depv - regX*b4;	 eM = lhs - rhs*b4;


 @following code does correct for missings@
  w = packr(eM~lhs~rhs);
  s_sq = (1/(n-k))*(w[.,1].*w[.,3:k+2])'(w[.,1].*w[.,3:k+2]);

	if hac .== 1; 
     p=1; do while p < hh;
	 wi =  1-(p/hh);
	 w1 = packr(eM[1+p:nM,1]~rhs[1+p:nM,.]~eM[1:nM-p,1]~rhs[1:nM-p,.]);
	 w2 = packr(eM[1+p:nM,1]~rhs[1:nM-p,.]~eM[1:nM-p,1]~rhs[1+p:nM,.]);
	 
     s_sq = s_sq + wi*(1/rows(w1))*(w1[.,1].*w1[.,2:k+1])'(w1[.,k+2].*w1[.,k+3:2*k+2])
                 + wi*(1/rows(w2))*(w2[.,1].*w2[.,2:k+1])'(w2[.,k+2].*w2[.,k+3:2*k+2]);
      @Bartlett weights@ 
     p = p+1; endo;
    endif;
  w = packr(rhs);
  s_sq = n*invpd(w'w)*s_sq*invpd(w'w);


tstat4 = b4[2,1]/(SQRT(s_sq[2,2]));

@Bernhardt test of forecast error on f - c1@
gamp = sumc(f .gt c1);
if ismiss(gamp);
delp = miss(0,0);
prob1 = miss(0,0);
else;
delp = sumc((f .gt c1).*(f .gt a));
prob1 = delp/gamp;
endif;
gamn = sumc(f .lt c1);
if ismiss(gamn);
deln = miss(0,0);
prob2 = miss(0,0);
else;
deln = sumc((f .lt c1).*(f .lt a));
prob2 = deln/gamn;
endif;
esd = 0.25*sqrt((1/gamp) + (1/gamn));
Sstat = 0.5 *(prob1 + prob2);
lb = Sstat - 2*esd;
ub = Sstat + 2*esd;
signif_h = ub .lt 0.5;
signif_a = lb .gt 0.5;


@to understand the apparent conflict between my adapted Gallo et al results and Bernhardt-type results@
n1 = sumc((f .gt c1).*(f1 .gt c1));
n2 = sumc((a .lt f).*(f .lt f1).*(f .gt c1).*(f1 .gt c1));
n3 = sumc((f .lt c1).*(f1 .lt c1));
n4 = sumc((a .gt f).*(f .gt f1).*(f .lt c1).*(f1 .lt c1));


retp(b1'~cdffc(tstat1^2,1,n - 2)~b2'~cdfTc(tstat2,n - 2)~sumc(abs(fe))~sumc(fe.*fe)~b3'~cdfTc(tstat3,n - 2)~b4'~cdfTc(tstat4,n - 2)~prob1~prob2~Sstat~signif_h~signif_a~(n1/n)~(n2/n1)~(n3/n)~(n4/n3));				  @cdfTc: right tail probability@
@2coefficients, 1 test, 2coefficients, 1 tests, abs errors, sqd errors, 2coefficients, 1 test, 2coefficients, 1 test @    
endp;


proc(1) = ggj_test(Z,gv);
local z1,f,f1,c1,n,regX,inXX,depv,e,s_sq,tstat1,tstat2,tstat3,tstat4,beta,gam,k;
if rows(gv) .gt 1;
z1=packr(z~gv);
z  = z1[.,1:cols(z1)-1];
gv = z1[.,cols(z1)];
else;
z= packr(z);
endif;
f =  Z[.,1];
f1 = Z[.,2];
c1 = Z[.,3];
n  = rows(Z);

@f: constant, f1 c1@ 	 
regX = ones(n,1)~f1~c1;
if rows(gv) .== rows(regX);
regX = regX~gv;
endif;
inXX = invpd(regX'regX);
depv = f;
beta = inXX*regX'depv;
e = depv - regX*beta;
k = cols(regX);
if hcse == 0;
s_sq = (1/(n-k))*(e'e)*invpd(regX'regX);
else; 
s_sq = (1/(n-k))*(e.*regX)'(e.*regX);
s_sq = n*invpd(regX'regX)*s_sq*invpd(regX'regX);
endif;

tstat1 = beta[2,1]/(SQRT(s_sq[2,2]));
tstat2 = beta[3,1]/(SQRT(s_sq[3,3]));


@f-c1: constant, f1 - c1, c1@ 
regX = ones(n,1)~(f1-c1)~c1;
if rows(gv) .== rows(regX);
regX = regX~gv;
endif;
inXX = invpd(regX'regX);
depv = f - c1;
gam  = inXX*regX'depv;
e = depv - regX*gam;
k = cols(regX);
if hcse == 0;
s_sq = (1/(n-k))*(e'e)*invpd(regX'regX);
else; 
s_sq = (1/(n-k))*(e.*regX)'(e.*regX);
s_sq = n*invpd(regX'regX)*s_sq*invpd(regX'regX);
endif;
tstat3 = gam[2,1]/(SQRT(s_sq[2,2]));
tstat4 = gam[3,1]/(SQRT(s_sq[3,3]));

retp(beta[2:3,1]'~cdffc(tstat1^2,1,n - 3)~cdffc(tstat2^2,1,n - 3)~gam[2:3,1]'~cdfTc(tstat3,n - 3)~cdfTc(tstat4,n - 3));				  @cdfTc: right tail probability@
@2coefficients, 2tests, 2coefficients, 2tests@    
endp;


Experiment = Experiment + 1;  endo;

end;
