@Uses data generated by herd.prg, to analyse relationship between the forecast errors of those who herd and their forecast biases@    

new; cls;
outwidth 180;
format /RDN 8,2;
library pgraph,co;

output file = c:\jmcb_16-171\tables.out reset; 

load p_q = c:\jmcb_16-171\inflation_q_dat;	 	@inflation - qly@
load y_q = c:\jmcb_16-171\output_q_dat;	  		@output- qly@ 
cv = 0.05;

case = 3; do while case .le 4;

if case .== 3; z = p_q;"Inflation, qly forecasts";endif;
if case .== 4; z = y_q;"Output, qly forecasts";   endif;

qlyres1 = miss(zeros(1,16),0);
qlyres3 = miss(zeros(1,14),0);

z = packr(z);
q = 4; do while q .ge 1;
temp =selif(z,z[.,2] .== q);
if ismiss(temp); GOTO nextq; endif;


n = rows(temp);
temp1    = selif(temp,temp[.,9] .ge 1 - cv);
temp2    = selif(temp,temp[.,9] .le cv);
tempRest = selif(temp,temp[.,9] .lt 1 - cv);
tempRest = selif(tempRest,tempRest[.,9] .gt cv);
p1 = rows(temp1);
p2 = rows(temp2);
pRest = rows(tempRest);
mae1 = sumc(temp1[.,10])/sumc(temp1[.,3]);
mse1 = sumc(temp1[.,11])/sumc(temp1[.,3]);
if ismiss(temp2); mae2 = miss(0,0); mse2 = miss(0,0); p2 = 0; 
else;
mae2 = sumc(temp2[.,10])/sumc(temp2[.,3]);
mse2 = sumc(temp2[.,11])/sumc(temp2[.,3]);
endif;
maeRest = sumc(tempRest[.,10])/sumc(tempRest[.,3]);
mseRest = sumc(tempRest[.,11])/sumc(tempRest[.,3]);

temp3 = selif(temp,temp[.,20] .lt 0.5);
p3 = rows(temp3);
if ismiss(temp3);
p3 = miss(0,0);
endif;

temp4 = selif(temp,temp[.,20] .gt 0.5);
p4 = rows(temp4);
if ismiss(temp4);
p4 = miss(0,0);
endif;

S_given_herd = median(temp1[.,20]);
if ismiss(temp2);
S_given_anti = miss(0,0);
else;
S_given_anti = median(temp2[.,20]);
endif;
S_given_neut = median(tempRest[.,20]);

qlyres1 = qlyres1|(q~n~(p1/n)~(p2/n)~(pRest/n)~mae1~mae2~maeRest~mse1~mse2~mseRest~(p3/n)~(p4/n)~S_given_herd~S_given_anti~S_given_neut); 

temp1    = selif(temp,temp[.,17] .ge 1 - cv);	 
temp2    = selif(temp,temp[.,17] .le cv);
tempRest = selif(temp,temp[.,17] .lt 1 - cv);
tempRest = selif(tempRest,tempRest[.,17] .gt cv);
p1 = rows(temp1);
p2 = rows(temp2);
pRest = rows(tempRest);
if ismiss(temp1); mae1 = miss(0,0); mse1 = miss(0,0); p1 = 0; 
else;
mae1 = sumc(temp1[.,10])/sumc(temp1[.,3]);
mse1 = sumc(temp1[.,11])/sumc(temp1[.,3]);
endif;
if ismiss(temp2); mae2 = miss(0,0); mse2 = miss(0,0); p2 = 0; 
else;
mae2 = sumc(temp2[.,10])/sumc(temp2[.,3]);
mse2 = sumc(temp2[.,11])/sumc(temp2[.,3]);
endif;
maeRest = sumc(tempRest[.,10])/sumc(tempRest[.,3]);
mseRest = sumc(tempRest[.,11])/sumc(tempRest[.,3]);

temp3 = selif(temp,temp[.,20] .lt 0.5);
p3 = rows(temp3);
if ismiss(temp3);
p3 = miss(0,0);
endif;

temp4 = selif(temp,temp[.,20] .gt 0.5);
p4 = rows(temp4);
if ismiss(temp4);
p4 = miss(0,0);
endif;

temp5 = selif(temp,temp[.,21] + temp[.,22]);
p5 = rows(temp5);
if ismiss(temp5);
p5 = miss(0,0);
endif;

qlyres3 = qlyres3|(q~n~(p1/n)~(p2/n)~(pRest/n)~mae1~mae2~maeRest~mse1~mse2~mseRest~(p3/n)~(p4/n)~(p5/n)); 

nextq:
q = q - 1; endo;

" T_2 Test Results";
" : # : -ve : +ve : rem ";
tex_table(qlyres1[.,1:5]);

" T_3 Test Results";
" : # : -ve : +ve : rem : CP<0.5 : CP>0.5";
tex_table(qlyres3[.,1:5 12 13]);

case = case + 1; endo;

@GGJ tests@;
load pq = c:\jmcb_16-171\inflation_GGJq_dat;	 	@inflation - qly@
load yq = c:\jmcb_16-171\output_GGJq_dat;  	 	@output - qly@
case = 1; do while case .le 2;
Gallotab = miss(zeros(1,5),0); 
if case .== 1; z = pq;	   @Inflation qly forecasts, Gallo et al@
elseif case .== 2; z = yq; @Output qly forecasts, Gallo et al@ 
endif;
z = packr(z);
q = 4; do while q .ge 1;
temp =selif(z,z[.,2] .== q);
if ismiss(temp); goto nextq_jgg; endif;
n = rows(temp);
temp1    = selif(temp,temp[.,7] .le cv);
p1 = rows(temp1)/n;
if ismiss(temp1); p1 = 0; endif;
w = (temp[.,7] .lt cv).*(temp[.,11] .gt 1- cv);
temp2    = selif(temp,w);
p2 = rows(temp2)/n;
if ismiss(temp2); p2 = 0; endif;
w =  (temp[.,11] .gt (1 - (cv/2))) + (temp[.,11] .lt cv/2);
temp3 = selif(temp,w); 
p3 = rows(temp3)/n;
if ismiss(temp3); p3 = 0; endif;
Gallotab  =Gallotab|(q~n~p1~p2~p3);
nextq_jgg:
q=q-1; endo;
" T_1 Test Results";
" :  # : beta_2 ne 0  : beta_2 ne 0 and gamma_2 < 0 :   gamma_2 ne 0 "; 
tex_table(Gallotab);
case = case + 1; endo; 



@	Formats a Gauss matrix as a tex table@
proc(0) = tex_table(x);
local r,c,i,j;
r=rows(x);
c=cols(x);
"\\begin{table}";
"\\caption{} ";
"\\label{} ";
"\\begin{tabular}{} ";
"\\hline";
i=1; do while i <= r;
j=1; do while j <= c-1;
x[i,j];;" & ";;
j=j+1; endo;
x[i,c] " \\\\ ";
i=i+1;endo;
"\\hline";
"\\end{tabular} ";
"\\end{table} ";
retp;
endp;
